//Un niveau standard : contient des liens et des noeuds !
package
{
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.display.Shape;
	import flash.events.*;

	public class Niveau extends Sprite
	{
		public var All_Noeuds:Array;//Contient l'arborescence sous forme de noeuds graphiques
		public var NbJetonsUtilises:int;
		public var NbJetonsToleres:int;

		private var JetonsUtilises:Array;
		private var Layer:Sprite;
		private var GrandPere:Noeud;

		public function Niveau(Niveau:Array,Hook:Array,Non_Extinctible:Array,NbJetonsToleres:int,Hauteur:int,Largeur:int)
		{
			this.All_Noeuds = new Array();
			this.NbJetonsToleres=NbJetonsToleres;
			this.JetonsUtilises=new Array();
			var Enfants:Array;
			var i:int;

			All_Noeuds=new Array(Niveau.length);
			for(i=0;i<Niveau.length;i++)
			{
				if(Niveau[i]!=null)
				{
					Enfants=new Array();
					for each(var Enfant:int in Niveau[i])
					{
						Enfants.push(All_Noeuds[Enfant]);
					}
					All_Noeuds[i]=AjoutNoeud(Enfants)
				}
				else
					All_Noeuds[i]=AjoutNoeud(null);
			}

			//Les options supplmentaires:
			//Hook
			//Inextinguible
			i=0;
			for each(var Child:Noeud in All_Noeuds)
			{
					if(Hook[i]==null)
						Hook[i]=0;
					if(Non_Extinctible[i]==null)
						Non_Extinctible[i]=false;
				Child.addHook(Hook[i]);
				Child.Is_Not_Eteignable(Non_Extinctible[i]);
				i++;
			}

			//Nombre de jetons utilisables
			for(i=0;i<NbJetonsToleres;i++)
			{
				JetonsUtilises[i]=new Noeud(new Array(),this);
				this.addChild(JetonsUtilises[i]);
				JetonsUtilises[i].x=Largeur-(i+1)*25;
				JetonsUtilises[i].y=15;
				JetonsUtilises[i].scaleX=JetonsUtilises[i].scaleY=.5;
			}

			this.graphics.beginFill(0xFFFFFF);
			this.graphics.drawRect(0, 0, Largeur, Hauteur);
			GrandPere=this.All_Noeuds[All_Noeuds.length-1];

		}

		public function CreerArbreParents(NoeudActuel:Noeud):void
		{
			for each(var Child:Noeud in NoeudActuel.Enfants)
			{//Smells like recursivity again ;-)
				Child.addParent(NoeudActuel);
				CreerArbreParents(Child);
			}
		}

		private function AjoutNoeud(Enfants:Array=null):Noeud
		{//Ajoute un noeud en mmoire, et retourne son occurence
			if(Enfants==null)
				Enfants=new Array();
			var NouveauNoeud:Noeud=new Noeud(Enfants,this);
			this.addChild(NouveauNoeud);
			NouveauNoeud.x=NouveauNoeud.y=-20
			return NouveauNoeud
		}

		public function UpdateNbJetons():void
		{
			this.NbJetonsUtilises = Math.ceil(GrandPere.CompterJetons());//Arrondir, car sinon 0.3333333+0.33333333+.333333333 != 1 et on obtient un jeton de moins.
			for(var i:int=0;i<NbJetonsToleres;i++)
			{
				JetonsUtilises[i].ChangeState((i<NbJetonsUtilises));
				if(i<NbJetonsUtilises)
					JetonsUtilises[i].scaleX=JetonsUtilises[i].scaleY=.7;
				else
					JetonsUtilises[i].scaleX=JetonsUtilises[i].scaleY=.5;
			}
		}

		public function Nettoyer():void
		{
			//Nettoyer le niveau
			GrandPere.DeleteYourself();
			All_Noeuds=new Array();
			//Il y a un bug qui empche la suppression des liens, donc on les vire manuellement.
			while(this.numChildren > 0)
			{
				this.removeChildAt(0);
			}
		}


	}
}